> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-wallet/generation/generatenewaccount.md).

# generateNewAccount

Derives the next account for an existing wallet. Returns a new wallet object with the additional account appended — the original wallet is not mutated.

***

### Usage

```ts
import { generateWallet, generateNewAccount } from '@stacks/wallet-sdk';

let wallet = await generateWallet({
  secretKey: 'your 24-word seed phrase here ...',
  password: 'my-secure-password',
});

console.log(wallet.accounts.length); // 1

// Add a second account
wallet = generateNewAccount(wallet);
console.log(wallet.accounts.length); // 2

// Add a third account
wallet = generateNewAccount(wallet);
console.log(wallet.accounts.length); // 3
```

#### Notes

* Each call derives the next sequential account index.
* The returned wallet is a new object — the original wallet is not mutated.
* Accounts are derived using the `DerivationType.Wallet` derivation path (`m/44'/5757'/0'/0`).

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/wallet-sdk/src/generate.ts#L70)

***

### Signature

```ts
function generateNewAccount(wallet: Wallet): Wallet;
```

***

### Returns

`Wallet`

A new `Wallet` object with the additional account appended to `wallet.accounts`.

***

### Parameters

#### wallet (required)

* **Type**: `Wallet`

The existing wallet to derive a new account for. The new account's index will be `wallet.accounts.length`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-wallet/generation/generatenewaccount.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
